import { Injectable, Inject } from '@angular/core';
import { HttpClient } from '@angular/common/http';

import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

import { _MODULE_CONFIG } from '../types/token';
import { ModuleConfig } from '../types/module-config';
import {
  Login2Request,
  Login2Response,
  encodeLogin2,
  decodeLogin2
} from '../models/login2';

@Injectable({
  providedIn: 'root'
})
export class PiService {
  constructor(
    @Inject(_MODULE_CONFIG) private moduleConfig: ModuleConfig,
    private httpClient: HttpClient
  ) {}

  public login2(req: Login2Request): Observable<Login2Response> {
    return this.httpClient
      .post<any>(
        this.moduleConfig.urls.login2,
        {},
        {
          params: encodeLogin2(req)
        }
      )
      .pipe(map(res => decodeLogin2(res)));
  }
}
